#include "client/rendering/Framebuffers.h"

void Framebuffers::resize(const Size& size) {
    world.resize(size);
    ssao.resize(size);
    ssaoBlur.resize(size);
    shadow.resize(size);
}

Error Framebuffers::init(const Size& size) {
    Error error =
        world.init(size, TextureFormat::float32(3), TextureFormat::float32(3),
                   TextureFormat::color8(4), TextureFormat::float32(1),
                   TextureFormat::depth32(true));
    if(error.has()) {
        return error;
    }
    error = ssao.init(size, TextureFormat::float32(1));
    if(error.has()) {
        return error;
    }
    error = ssaoBlur.init(size, TextureFormat::float32(1));
    if(error.has()) {
        return error;
    }
    return shadow.init(size, TextureFormat::depth32());
}