#include "client/rendering/Shaders.h"

Error Shaders::init() {
    Error error = world.compile("resources/shader/world.vs", nullptr,
                                "resources/shader/world.fs");
    if(error.has()) {
        return error;
    }
    error = ssao.compile("resources/shader/ssao.vs", nullptr,
                         "resources/shader/ssao.fs");
    if(error.has()) {
        return error;
    }
    error = ssaoBlur.compile("resources/shader/ssaoBlur.vs", nullptr,
                             "resources/shader/ssaoBlur.fs");
    if(error.has()) {
        return error;
    }
    error = shadow.compile("resources/shader/worldShadow.vs", nullptr,
                           "resources/shader/worldShadow.fs");
    if(error.has()) {
        return error;
    }
    error = postWorld.compile("resources/shader/worldPost.vs", nullptr,
                              "resources/shader/worldPost.fs");
    if(error.has()) {
        return error;
    }
    return overlay.compile("resources/shader/overlay.vs", nullptr,
                           "resources/shader/overlay.fs");
}