#ifndef WORLDRENDERER_H
#define WORLDRENDERER_H

#include "client/rendering/Mesh.h"
#include "common/world/World.h"
#include "rendering/FileTexture.h"

class WorldRenderer {
    const World& world;
    Mesh mesh;
    FileTexture texture;

public:
    WorldRenderer(const World& world);
    bool init();

    void render();
    void addCube(TypedBuffer<Triangle>& buffer, float x, float y, float z);
    bool isAir(int x, int y, int z) const;
};

#endif