#ifndef BLOCK_H
#define BLOCK_H

#include "common/block/BlockTypes.h"
#include "common/utils/CollisionBox.h"
#include "utils/ArrayList.h"
#include "utils/List.h"

class Block final {
    BlockId id;
    BlockName registry;
    ArrayList<CollisionBox, 1> boxes;

public:
    Block(BlockId id, const BlockName& registry);

    BlockId getId() const;
    const BlockName& getRegistry() const;

    void addBoxes(List<CollisionBox>& list, const Vector3& pos) const;
};

#endif